import { RequiredProps } from '@mike-north/types';
export declare type BasicPropPredicate<T, K extends keyof T> = RegExp | ((val: T[K]) => boolean) | T[K];
export interface NumberPropPredicateBase {
    gt: number;
    lt: number;
    gte: number;
    lte: number;
}
export declare type NumberPropPredicateGt = RequiredProps<Partial<NumberPropPredicateBase>, 'gt'>;
export declare type NumberPropPredicateGte = RequiredProps<Partial<NumberPropPredicateBase>, 'gte'>;
export declare type NumberPropPredicateLt = RequiredProps<Partial<NumberPropPredicateBase>, 'lt'>;
export declare type NumberPropPredicateLte = RequiredProps<Partial<NumberPropPredicateBase>, 'lte'>;
export declare type NumberPropPredicate = NumberPropPredicateGt | NumberPropPredicateGte | NumberPropPredicateLt | NumberPropPredicateLte;
export declare type PropPredicate<T, K extends keyof T> = T[K] extends (number | undefined) ? NumberPropPredicate | BasicPropPredicate<T, K> : BasicPropPredicate<T, K>;
export declare type PredicateObject<T, K extends keyof T = keyof T> = {
    [KK in K]: PropPredicate<T, KK>;
};
export declare function isNumberPredicateObject(p: any): boolean;
export declare function toPredicate<T>(loc: PredicateObject<T>): (item: T) => boolean;
